#ifndef _E_MAIL_REMOTE_GLUE_FOLDERINFO_H_
#define _E_MAIL_REMOTE_GLUE_FOLDERINFO_H_

#include <glib/gmacros.h>
#include <glib-object.h>

#include "Evolution-DataServer-Mail.h"
#include "e-mail-remote-glue-msgiter.h"
#include "e-mail-remote-glue-msgstream.h"

G_BEGIN_DECLS

#define E_TYPE_MAIL_REMOTE_GLUE_FOLDERINFO           (e_mail_remote_glue_folderinfo_get_type ())
#define E_MAIL_REMOTE_GLUE_FOLDERINFO(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), E_TYPE_MAIL_REMOTE_GLUE_FOLDERINFO, \
									 EMailRemoteGlueFolderInfo))
#define E_MAIL_REMOTE_GLUE_FOLDERINFO_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), E_TYPE_MAIL_REMOTE_GLUE_FOLDERINFO,  \
								      EMailRemoteGlueFolderInfoClass))
#define E_IS_MAIL_REMOTE_GLUE_FOLDERINFO(obj)        (G_TYPE_CHECK_INSTANCE_TYPE ((obj), E_TYPE_MAIL_REMOTE_GLUE_FOLDERINFO))
#define E_IS_MAIL_REMOTE_GLUE_FOLDERINFO_CLASS(klass)(G_TYPE_CHECK_CLASS_TYPE ((klass), E_TYPE_MAIL_REMOTE_GLUE_FOLDERINFO))

typedef struct _EMailRemoteGlueFolderInfo EMailRemoteGlueFolderInfo;
typedef struct _EMailRemoteGlueFolderInfoPrivate EMailRemoteGlueFolderInfoPrivate;
typedef struct _EMailRemoteGlueFolderInfoClass EMailRemoteGlueFolderInfoClass;

struct _EMailRemoteGlueFolderInfo {
  GObject parent_instance;  

  /*< private >*/
  EMailRemoteGlueFolderInfoPrivate *priv;
};

struct _EMailRemoteGlueFolderInfoClass {
  GObjectClass parent_class;
};

G_END_DECLS

EMailRemoteGlueFolderInfo* e_mail_remote_glue_folderinfo_new (void);
EMailRemoteGlueFolderInfo * e_mail_remote_glue_folderinfo_new_from_EMFolderInfo (Evolution_Mail_FolderInfo info);
EMailRemoteGlueFolderInfo * e_mail_remote_glue_folderinfo_new_clone (EMailRemoteGlueFolderInfo* info);
char* e_mail_remote_glue_folderinfo_peek_name (EMailRemoteGlueFolderInfo* finfo);
char* e_mail_remote_glue_folderinfo_peek_full_name (EMailRemoteGlueFolderInfo* finfo);
Evolution_Mail_Folder e_mail_remote_glue_folderinfo_EMFolder (EMailRemoteGlueFolderInfo* finfo);
EMailRemoteGlueMsgIterator* e_mail_remote_glue_folderinfo_get_messages (EMailRemoteGlueFolderInfo* emrg_finfo);
EMailRemoteGlueMsgStream* e_mail_remote_glue_folderinfo_get_message (EMailRemoteGlueFolderInfo* finfo, const char* uid);

#endif
