#ifndef _E_MAIL_REMOTE_GLUE_MESSAGEINFO_H_
#define _E_MAIL_REMOTE_GLUE_MESSAGEINFO_H_

#include <glib/gmacros.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define E_TYPE_MAIL_REMOTE_GLUE_MESSAGEINFO           (e_mail_remote_glue_messageinfo_get_type ())
#define E_MAIL_REMOTE_GLUE_MESSAGEINFO(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), E_TYPE_MAIL_REMOTE_GLUE_MESSAGEINFO, \
									 EMailRemoteGlueMessageInfo))
#define E_MAIL_REMOTE_GLUE_MESSAGEINFO_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), E_TYPE_MAIL_REMOTE_GLUE_MESSAGEINFO,  \
								      EMailRemoteGlueMessageInfoClass))
#define E_IS_MAIL_REMOTE_GLUE_MESSAGEINFO(obj)        (G_TYPE_CHECK_INSTANCE_TYPE ((obj), E_TYPE_MAIL_REMOTE_GLUE_MESSAGEINFO))
#define E_IS_MAIL_REMOTE_GLUE_MESSAGEINFO_CLASS(klass)(G_TYPE_CHECK_CLASS_TYPE ((klass), E_TYPE_MAIL_REMOTE_GLUE_MESSAGEINFO))

typedef struct _Evolution_Mail_UserTag EMUserTag;
typedef struct _EMailRemoteGlueMessageInfo EMailRemoteGlueMessageInfo;
typedef struct _EMailRemoteGlueMessageInfoPrivate EMailRemoteGlueMessageInfoPrivate;
typedef struct _EMailRemoteGlueMessageInfoClass EMailRemoteGlueMessageInfoClass;

struct _EMailRemoteGlueMessageInfo {
  GObject parent_instance;  

  /*< private >*/
  EMailRemoteGlueMessageInfoPrivate *priv;
};

struct _EMailRemoteGlueMessageInfoClass {
  GObjectClass parent_class;
};

struct _Evolution_Mail_UserTag {
  char* name;
  char* value;
};

G_END_DECLS

EMailRemoteGlueMessageInfo* e_mail_remote_glue_messageinfo_new (void);
EMailRemoteGlueMessageInfo * e_mail_remote_glue_messageinfo_new_from_EMMessageInfo (Evolution_Mail_MessageInfo info);
EMailRemoteGlueMessageInfo * e_mail_remote_glue_messageinfo_new_clone (EMailRemoteGlueMessageInfo* info);
void e_mail_remote_glue_messageinfo_free_user_tag_list (GSList* user_tag_list);
char* e_mail_remote_glue_messageinfo_peek_uid (EMailRemoteGlueMessageInfo* msginfo);
char* e_mail_remote_glue_messageinfo_peek_subject (EMailRemoteGlueMessageInfo* msginfo);
char* e_mail_remote_glue_messageinfo_peek_to (EMailRemoteGlueMessageInfo* msginfo);
char* e_mail_remote_glue_messageinfo_peek_from (EMailRemoteGlueMessageInfo* msginfo);
long e_mail_remote_glue_messageinfo_peek_flags (EMailRemoteGlueMessageInfo* msginfo);
GSList* e_mail_remote_glue_messageinfo_peek_user_flags (EMailRemoteGlueMessageInfo* msginfo);
GSList* e_mail_remote_glue_messageinfo_peek_user_tags (EMailRemoteGlueMessageInfo* msginfo);

#endif
